"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const account_command_1 = require("../../account-command");
class AccountExport extends account_command_1.WithPassphrase {
    async run() {
        const { args } = this.parse(AccountExport);
        const passphrase = await this.getPassphrase();
        this.spinner.start('Exporting account');
        const data = await this.execute({
            instanceHash: await this.engineServiceInstance(account_command_1.WithPassphrase.SERVICE_NAME),
            taskKey: 'export',
            inputs: JSON.stringify({
                address: args.ADDRESS,
                passphrase,
            })
        });
        this.spinner.stop();
        this.styledJSON(data);
        return data;
    }
}
AccountExport.description = 'Export an existing account';
AccountExport.flags = Object.assign({}, account_command_1.WithPassphrase.flags);
AccountExport.args = [{
        name: 'ADDRESS',
        required: true
    }];
exports.default = AccountExport;
