import { Service } from 'mesg-js/lib/api';
import Command from '../../root-command';
export default class ServiceCompile extends Command {
    static description: string;
    static flags: {
        help: import("@oclif/parser/lib/flags").IBooleanFlag<void>;
        quiet: import("@oclif/parser/lib/flags").IBooleanFlag<boolean>;
        silent: import("@oclif/parser/lib/flags").IBooleanFlag<boolean>;
    };
    static args: {
        name: string;
        description: string;
        default: string;
    }[];
    private readonly IPFS;
    run(): Promise<Service>;
    parseYml(content: string, source: string): Service;
    getAuthorizedServiceInfo(id: string, versionHash: string): Promise<{
        sid: string;
        source: string;
        type: string;
    }>;
    processUrl(url: string): Promise<string>;
    private deploySources;
    private upload;
}
