"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const root_command_1 = tslib_1.__importDefault(require("../../root-command"));
class ServiceCreate extends root_command_1.default {
    async run() {
        const { args } = this.parse(ServiceCreate);
        this.spinner.start('Create service');
        const resp = await this.api.service.create(JSON.parse(args.DEFINITION));
        this.spinner.stop(resp.hash);
        return resp;
    }
}
ServiceCreate.description = 'Create a service';
ServiceCreate.flags = Object.assign({}, root_command_1.default.flags);
ServiceCreate.args = [{
        name: 'DEFINITION',
        required: true,
        description: 'Service\'s definition. Use service:compile first to build service definition'
    }];
exports.default = ServiceCreate;
