"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const command_1 = require("@oclif/command");
const cli_ux_1 = tslib_1.__importDefault(require("cli-ux"));
const root_command_1 = tslib_1.__importDefault(require("../../root-command"));
const service_resolver_1 = tslib_1.__importDefault(require("../../utils/service-resolver"));
class ServiceDelete extends root_command_1.default {
    async run() {
        const { argv, flags } = this.parse(ServiceDelete);
        if (!flags.confirm && !await cli_ux_1.default.confirm('Are you sure?'))
            return [];
        this.spinner.start('Deleting service(s)');
        for (const hash of argv) {
            const serviceHash = await service_resolver_1.default(this.api, hash);
            this.spinner.status = serviceHash;
            await this.api.service.delete({ hash: serviceHash });
        }
        this.spinner.stop();
        return argv;
    }
}
ServiceDelete.description = 'Delete one or many services';
ServiceDelete.flags = Object.assign({}, root_command_1.default.flags, { confirm: command_1.flags.boolean({ description: 'Confirm deletion', default: false }) });
ServiceDelete.strict = false;
ServiceDelete.args = [{
        name: 'SERVICE_HASH...',
        required: true,
    }];
exports.default = ServiceDelete;
