"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const cli_ux_1 = tslib_1.__importDefault(require("cli-ux"));
const root_command_1 = tslib_1.__importDefault(require("../../root-command"));
class ServiceList extends root_command_1.default {
    async run() {
        const { flags } = this.parse(ServiceList);
        const { services } = await this.api.service.list({});
        const { instances } = await this.api.instance.list({});
        if (!services)
            return [];
        cli_ux_1.default.table(services, {
            hash: { header: 'HASH', get: x => x.hash },
            sid: { header: 'SID', get: x => x.sid },
            instances: {
                header: 'INSTANCES',
                get: x => (instances || [])
                    .filter(y => y.serviceHash === x.hash)
                    .map(x => x.hash)
                    .join('\n')
            }
        }, Object.assign({ printLine: this.log }, flags));
        return instances;
    }
}
ServiceList.description = 'List running services';
ServiceList.flags = Object.assign({}, root_command_1.default.flags, cli_ux_1.default.table.flags());
exports.default = ServiceList;
