import { flags } from '@oclif/command';
import Command from './root-command';
export interface Manifest {
    version: 1;
    service: {
        definition: any;
        readme: string;
        hash: string;
        hashVersion: '1';
        deployment: {
            type: 'ipfs';
            source: string;
        };
    };
}
export default abstract class MarketplaceCommand extends Command {
    static flags: {
        account: flags.IOptionFlag<string | undefined>;
        passphrase: flags.IOptionFlag<string | undefined>;
        help: import("@oclif/parser/lib/flags").IBooleanFlag<void>;
        quiet: import("@oclif/parser/lib/flags").IBooleanFlag<boolean>;
        silent: import("@oclif/parser/lib/flags").IBooleanFlag<boolean>;
    };
    static SERVICE_NAME: string;
    sign(account: string, data: any, passphrase: string): Promise<any>;
    getAccount(): Promise<string>;
    getPassphrase(): Promise<string>;
}
