import { Command } from '@oclif/command';
import { IConfig } from '@oclif/config';
import { API, ExecutionCreateInputs, InfoOutputs } from 'mesg-js/lib/api';
export default abstract class extends Command {
    static flags: {
        help: import("@oclif/parser/lib/flags").IBooleanFlag<void>;
        quiet: import("@oclif/parser/lib/flags").IBooleanFlag<boolean>;
        silent: import("@oclif/parser/lib/flags").IBooleanFlag<boolean>;
    };
    api: API;
    private readonly _app;
    constructor(argv: string[], config: IConfig);
    readonly spinner: import("cli-ux").ActionBase | {
        start: () => void;
        stop: (message?: string | undefined) => void | null;
        status: null;
    };
    log(message?: string, ...args: any[]): void;
    styledJSON(data: any): void;
    catch(err: Error): Promise<void>;
    execute(request: ExecutionCreateInputs): Promise<any>;
    info(): InfoOutputs;
    engineServiceInstance(key: string): Promise<string>;
}
