"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = async (api, sidOrHash) => {
    try {
        await api.service.get({ hash: sidOrHash });
        return sidOrHash;
    }
    catch (_a) {
        const { services } = await api.service.list({});
        const match = services.filter(x => x.sid === sidOrHash);
        if (match.length === 0)
            throw new Error(`no service matching ${sidOrHash}`);
        if (match.length > 1)
            throw new Error(`multiple services matching ${sidOrHash}`);
        return match[0].hash;
    }
};
